Index: trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/ParticleSwarmOptimizationMainLoop.cs
===================================================================
--- trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/ParticleSwarmOptimizationMainLoop.cs	(revision 5560)
+++ trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/ParticleSwarmOptimizationMainLoop.cs	(revision 5560)
@@ -0,0 +1,199 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Operators;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Parameters;
+using HeuristicLab.Data;
+using HeuristicLab.Analysis;
+using HeuristicLab.Optimization;
+using HeuristicLab.Random;
+using HeuristicLab.Optimization.Operators;
+using HeuristicLab.Encodings.RealVectorEncoding;
+
+namespace HeuristicLab.Algorithms.ParticleSwarmOptimization {
+  [Item("ParticleSwarmOptimizationMainLoop", "An operator which represents the main loop of a particle swarm optimization algorithm.")]
+  [StorableClass]
+  public class ParticleSwarmOptimizationMainLoop : AlgorithmOperator {
+    #region Parameter Properties
+    public IValueLookupParameter<IRandom> RandomParameter {
+      get { return (IValueLookupParameter<IRandom>)Parameters["Random"]; }
+    }
+    public IValueLookupParameter<IntValue> SwarmSizeParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["SwarmSize"]; }
+    }
+    public IValueLookupParameter<IntValue> MaxIterationsParameter {
+      get { return (IValueLookupParameter<IntValue>)Parameters["MaxIterations"]; }
+    }
+    public IValueLookupParameter<IOperator> AnalyzerParameter {
+      get { return (IValueLookupParameter<IOperator>)Parameters["Analyzer"]; }
+    }
+    public IValueLookupParameter<DoubleValue> InertiaParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["Inertia"]; }
+    }
+    public IValueLookupParameter<DoubleValue> PersonalBestAttractionParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["PersonalBestAttraction"]; }
+    }
+    public IValueLookupParameter<DoubleValue> NeighborsBestAttractionParameter {
+      get { return (IValueLookupParameter<DoubleValue>)Parameters["NeighborsBestAttraction"]; }
+    }
+    public IValueLookupParameter<DoubleMatrix> VelocityBoundsParameter {
+      get { return (IValueLookupParameter<DoubleMatrix>)Parameters["VelocityBounds"]; }
+    }                                     
+    public IValueLookupParameter<IOperator> ParticleUpdaterParameter {
+      get { return (IValueLookupParameter<IOperator>)Parameters["ParticleUpdater"]; }
+    }
+    public IValueLookupParameter<IOperator> TopologyUpdaterParameter {
+      get { return (IValueLookupParameter<IOperator>)Parameters["TopologyUpdater"]; }
+    }
+    public IValueLookupParameter<IOperator> InertiaUpdaterParameter {
+      get { return (IValueLookupParameter<IOperator>)Parameters["InertiaUpdater"]; }
+    }
+    public IValueLookupParameter<VariableCollection> ResultsParameter {
+      get { return (IValueLookupParameter<VariableCollection>)Parameters["Results"]; }
+    }
+    public IValueLookupParameter<IOperator> EvaluatorParameter {
+      get { return (IValueLookupParameter<IOperator>)Parameters["Evaluator"]; }
+    }
+    #endregion
+                                                                 
+    public ParticleSwarmOptimizationMainLoop()
+      : base() {
+      Initialize();
+    }
+
+    [StorableConstructor]
+    protected ParticleSwarmOptimizationMainLoop(bool deserializing) : base(deserializing) { }
+    protected ParticleSwarmOptimizationMainLoop(ParticleSwarmOptimizationMainLoop original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ParticleSwarmOptimizationMainLoop(this, cloner);
+    }
+
+    private void Initialize() {
+      #region Create parameters
+      Parameters.Add(new ValueLookupParameter<IRandom>("Random", "A pseudo random number generator."));
+      Parameters.Add(new ValueLookupParameter<IntValue>("SwarmSize", "Size of the particle swarm.", new IntValue(10)));
+      Parameters.Add(new ValueLookupParameter<IntValue>("MaxIterations", "Maximal number of iterations.", new IntValue(1000)));
+      
+      Parameters.Add(new ValueLookupParameter<IOperator>("Analyzer", "The operator used to analyze each generation."));
+
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("Inertia", "Inertia weight on a particle's movement (omega)."));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("PersonalBestAttraction", "Weight for particle's pull towards its personal best soution (phi_p)."));
+      Parameters.Add(new ValueLookupParameter<DoubleValue>("NeighborsBestAttraction", "Weight for pull towards the neighborhood best solution or global best solution in case of a totally connected topology (phi_g)."));
+     
+      Parameters.Add(new ValueLookupParameter<IOperator>("ParticleUpdater", "Operator that calculates new position and velocity of a particle"));
+      Parameters.Add(new ValueLookupParameter<IOperator>("TopologyUpdater", "Updates the neighborhood description vectors"));
+      Parameters.Add(new ValueLookupParameter<IOperator>("InertiaUpdater", "Updates the omega parameter"));
+      Parameters.Add(new ValueLookupParameter<IOperator>("Evaluator", "Evaluates a particle solution."));
+
+      Parameters.Add(new ValueLookupParameter<VariableCollection>("Results", "The variable collection where results should be stored."));
+      #endregion
+
+      #region Create operators
+      Placeholder evaluatorPlaceholder = new Placeholder();
+      Placeholder analyzerPlaceholder = new Placeholder();
+      UniformSubScopesProcessor uniformSubScopeProcessor = new UniformSubScopesProcessor();
+      Placeholder particleUpdaterPlaceholder = new Placeholder();
+      Placeholder topologyUpdaterPlaceholder = new Placeholder();
+      UniformSubScopesProcessor uniformSubscopesProcessor2 = new UniformSubScopesProcessor();
+      UniformSubScopesProcessor evaluationProcessor = new UniformSubScopesProcessor();
+      NeighborUpdater neighborUpdater = new NeighborUpdater();
+      ISwarmUpdater swarmUpdater = new RealVectorSwarmUpdater();
+      IntCounter currentIterationCounter = new IntCounter();
+      Comparator currentIterationComparator = new Comparator();
+      ConditionalBranch conditionalBranch = new ConditionalBranch();
+      Placeholder velocityBoundsUpdaterPlaceholder = new Placeholder();
+      Placeholder omegaUpdaterPlaceholder = new Placeholder();
+      #endregion
+
+      #region Create operator graph
+      //OperatorGraph.InitialOperator = analyzerPlaceholder;
+
+      //analyzerPlaceholder.Name = "(Analyzer)";
+      //analyzerPlaceholder.OperatorParameter.ActualName = "Analyzer";
+      //analyzerPlaceholder.Successor = uniformSubScopeProcessor;
+
+      //uniformSubScopeProcessor.Operator = particleUpdaterPlaceholder;
+      //uniformSubScopeProcessor.Successor = evaluationProcessor;
+
+      //particleUpdaterPlaceholder.Name = "(ParticleUpdater)";
+      //particleUpdaterPlaceholder.OperatorParameter.ActualName = "ParticleUpdater";
+
+      //evaluationProcessor.Parallel = new BoolValue(true);
+      //evaluationProcessor.Operator = evaluatorPlaceholder;
+      //evaluationProcessor.Successor = topologyUpdaterPlaceholder;
+
+      //evaluatorPlaceholder.Name = "(Evaluator)";
+      //evaluatorPlaceholder.OperatorParameter.ActualName = "Evaluator";
+
+      //topologyUpdaterPlaceholder.Name = "(TopologyUpdater)";
+      //topologyUpdaterPlaceholder.OperatorParameter.ActualName = "TopologyUpdater";
+      //topologyUpdaterPlaceholder.Successor = neighborUpdater;
+
+      //neighborUpdater.Successor = uniformSubscopesProcessor2;
+
+      //uniformSubscopesProcessor2.Operator = swarmUpdater;
+      //uniformSubscopesProcessor2.Successor = analyzerPlaceholder;
+
+      //analyzerPlaceholder.Name = "(Analyzer)";
+      //analyzerPlaceholder.OperatorParameter.ActualName = "Analyzer";
+      //analyzerPlaceholder.Successor = currentIterationCounter;
+
+      //currentIterationCounter.Name = "CurrentIteration++";
+      //currentIterationCounter.ValueParameter.ActualName = "CurrentIteration";
+      //currentIterationCounter.Successor = omegaUpdaterPlaceholder;
+
+      //omegaUpdaterPlaceholder.Name = "(Inertia Updater)";
+      //omegaUpdaterPlaceholder.OperatorParameter.ActualName = "InertiaUpdater";
+      //omegaUpdaterPlaceholder.Successor = velocityBoundsUpdaterPlaceholder;
+
+      //velocityBoundsUpdaterPlaceholder.Name = "(Velocity Bounds Updater)";
+      //velocityBoundsUpdaterPlaceholder.OperatorParameter.ActualName = "VelocityBoundsUpdater";
+      //velocityBoundsUpdaterPlaceholder.Successor = currentIterationComparator;
+
+      //currentIterationComparator.LeftSideParameter.ActualName = "CurrentIteration";
+      //currentIterationComparator.Comparison = new Comparison(ComparisonType.Less);
+      //currentIterationComparator.RightSideParameter.ActualName = "MaxIterations";
+      //currentIterationComparator.ResultParameter.ActualName = "ContinueIteration";
+      //currentIterationComparator.Successor = conditionalBranch;
+
+      //conditionalBranch.Name = "ContinueIteration?";
+      //conditionalBranch.ConditionParameter.ActualName = "ContinueIteration";
+      //conditionalBranch.TrueBranch = uniformSubScopeProcessor;
+      #endregion
+    }
+
+    public override IOperation Apply() {
+      if (this.ParticleUpdaterParameter.ActualValue == null)
+        return null;
+      return base.Apply();
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/RandomTopologyInitializer.cs
===================================================================
--- trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/RandomTopologyInitializer.cs	(revision 5527)
+++ trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/RandomTopologyInitializer.cs	(revision 5560)
@@ -25,5 +25,4 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
-using HeuristicLab.Encodings.IntegerVectorEncoding;
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -66,5 +65,5 @@
 
     public override IOperation Apply() {
-      ItemArray<IntegerVector> neighbors = new ItemArray<IntegerVector>(SwarmSize);
+      ItemArray<IntArray> neighbors = new ItemArray<IntArray>(SwarmSize);
       for (int i = 0; i < SwarmSize; i++) {
         var numbers = Enumerable.Range(0, SwarmSize).ToList();
@@ -76,5 +75,5 @@
           numbers.RemoveAt(index);
         }
-        neighbors[i] = new IntegerVector(selectedNumbers.ToArray());
+        neighbors[i] = new IntArray(selectedNumbers.ToArray());
       }
       Neighbors = neighbors;
Index: trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/RingTopologyInitializer.cs
===================================================================
--- trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/RingTopologyInitializer.cs	(revision 5527)
+++ trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/RingTopologyInitializer.cs	(revision 5560)
@@ -22,6 +22,6 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Encodings.IntegerVectorEncoding;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Data;
 
 namespace HeuristicLab.Algorithms.ParticleSwarmOptimization {
@@ -43,7 +43,7 @@
 
     public override IOperation Apply() {
-      ItemArray<IntegerVector> neighbors = new ItemArray<IntegerVector>(SwarmSize);
+      ItemArray<IntArray> neighbors = new ItemArray<IntArray>(SwarmSize);
       for (int i = 0; i < SwarmSize; i++) {
-        neighbors[i] = new IntegerVector(new[] { (SwarmSize + i - 1) % SwarmSize, (i + 1) % SwarmSize });
+        neighbors[i] = new IntArray(new[] { (SwarmSize + i - 1) % SwarmSize, (i + 1) % SwarmSize });
       }
       Neighbors = neighbors;
Index: trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/TopologyInitializer.cs
===================================================================
--- trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/TopologyInitializer.cs	(revision 5527)
+++ trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/TopologyInitializer.cs	(revision 5560)
@@ -23,6 +23,6 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
-using HeuristicLab.Encodings.IntegerVectorEncoding;
 using HeuristicLab.Operators;
+using HeuristicLab.Optimization; 
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
@@ -37,7 +37,8 @@
 
     #region Parameters
-    public IScopeTreeLookupParameter<IntegerVector> NeighborsParameter {
-      get { return (IScopeTreeLookupParameter<IntegerVector>)Parameters["Neighbors"]; }
+    public IScopeTreeLookupParameter<IntArray> NeighborsParameter {
+      get { return (IScopeTreeLookupParameter<IntArray>)Parameters["Neighbors"]; }
     }
+
     public ILookupParameter<IntValue> SwarmSizeParameter {
       get { return (ILookupParameter<IntValue>)Parameters["SwarmSize"]; }
@@ -47,5 +48,5 @@
 
     #region Parameter Values
-    protected ItemArray<IntegerVector> Neighbors {
+    protected ItemArray<IntArray> Neighbors {
       get { return NeighborsParameter.ActualValue; }
       set { NeighborsParameter.ActualValue = value; }
@@ -60,10 +61,10 @@
     protected TopologyInitializer(bool deserializing) : base(deserializing) { }
     protected TopologyInitializer(TopologyInitializer original, Cloner cloner) : base(original, cloner) { }
+    
     public TopologyInitializer() {
-      Parameters.Add(new ScopeTreeLookupParameter<IntegerVector>("Neighbors", "The list of neighbors for each particle."));
+      Parameters.Add(new ScopeTreeLookupParameter<IntArray>("Neighbors", "The list of neighbors for each particle."));
       Parameters.Add(new LookupParameter<IntValue>("SwarmSize", "Number of particles in the swarm."));
     }
     #endregion
-
   }
 
Index: trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/VonNeumannTopologyInitializer.cs
===================================================================
--- trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/VonNeumannTopologyInitializer.cs	(revision 5527)
+++ trunk/sources/HeuristicLab.Algorithms.ParticleSwarmOptimization/3.3/VonNeumannTopologyInitializer.cs	(revision 5560)
@@ -22,6 +22,6 @@
 using HeuristicLab.Common;
 using HeuristicLab.Core;
-using HeuristicLab.Encodings.IntegerVectorEncoding;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Data;
 
 namespace HeuristicLab.Algorithms.ParticleSwarmOptimization {
@@ -44,7 +44,7 @@
 
     public override IOperation Apply() {
-      ItemArray<IntegerVector> neighbors = new ItemArray<IntegerVector>(SwarmSize);
+      ItemArray<IntArray> neighbors = new ItemArray<IntArray>(SwarmSize);
       for (int i = 0; i < SwarmSize; i++) {
-        neighbors[i] = new IntegerVector(new[] {
+        neighbors[i] = new IntArray(new[] {
           (SwarmSize + i-2) % SwarmSize,
           (SwarmSize + i-1) % SwarmSize,
Index: trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/HeuristicLab.Encodings.RealVectorEncoding-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/HeuristicLab.Encodings.RealVectorEncoding-3.3.csproj	(revision 5527)
+++ trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/HeuristicLab.Encodings.RealVectorEncoding-3.3.csproj	(revision 5560)
@@ -104,4 +104,5 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="ParticleOperators\RealVectorParticleCreator.cs" />
     <Compile Include="Crossovers\BlendAlphaBetaCrossover.cs" />
     <Compile Include="Interfaces\IRealVectorManipulator.cs" />
@@ -111,5 +112,12 @@
     <Compile Include="BoundsChecker.cs" />
     <Compile Include="Creators\UniformRandomRealVectorCreator.cs" />
+    <Compile Include="Interfaces\IRealVectorParticleCreator.cs" />
+    <Compile Include="Interfaces\IRealVectorParticleUpdater.cs" />
+    <Compile Include="Interfaces\IRealVectorSwarmUpdater.cs" />
     <Compile Include="Manipulators\SelfAdaptiveNormalAllPositionsManipulator.cs" />
+    <Compile Include="ParticleOperators\RealVectorNeighborhoodParticleUpdater.cs" />
+    <Compile Include="ParticleOperators\RealVectorParticleUpdater.cs" />
+    <Compile Include="ParticleOperators\RealVectorSwarmUpdater.cs" />
+    <Compile Include="ParticleOperators\RealVectorTotallyConnectedParticleUpdater.cs" />
     <Compile Include="RealVectorCreator.cs" />
     <Compile Include="RealVectorCrossover.cs" />
@@ -230,4 +238,5 @@
     </BootstrapperPackage>
   </ItemGroup>
+  <ItemGroup />
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
Index: trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/Interfaces/IRealVectorParticleCreator.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/Interfaces/IRealVectorParticleCreator.cs	(revision 5560)
+++ trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/Interfaces/IRealVectorParticleCreator.cs	(revision 5560)
@@ -0,0 +1,34 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Optimization;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+
+namespace HeuristicLab.Encodings.RealVectorEncoding {
+  public interface IRealVectorParticleCreator : IParticleCreator, IRealVectorOperator {
+    ILookupParameter<IntValue> ProblemSizeParameter { get; }
+    ILookupParameter<RealVector> RealVectorParameter { get; }
+    ILookupParameter<RealVector> PersonalBestParameter { get; }
+    IValueLookupParameter<DoubleMatrix> BoundsParameter { get; }
+    ILookupParameter<RealVector> VelocityParameter { get; }
+  }
+}
Index: trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/Interfaces/IRealVectorParticleUpdater.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/Interfaces/IRealVectorParticleUpdater.cs	(revision 5560)
+++ trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/Interfaces/IRealVectorParticleUpdater.cs	(revision 5560)
@@ -0,0 +1,35 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Encodings.RealVectorEncoding {
+  public interface IRealVectorParticleUpdater : IParticleUpdater, IRealVectorOperator {
+    ILookupParameter<RealVector> VelocityParameter { get; }
+    ILookupParameter<DoubleMatrix> VelocityBoundsParameter { get; }
+    ILookupParameter<RealVector> RealVectorParameter { get; }
+    ILookupParameter<DoubleMatrix> BoundsParameter { get; }
+    ILookupParameter<RealVector> PersonalBestParameter { get; }
+    ILookupParameter<RealVector> NeighborsBestParameter { get; }
+  }
+}
Index: trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/Interfaces/IRealVectorSwarmUpdater.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/Interfaces/IRealVectorSwarmUpdater.cs	(revision 5560)
+++ trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/Interfaces/IRealVectorSwarmUpdater.cs	(revision 5560)
@@ -0,0 +1,31 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Optimization; 
+
+namespace HeuristicLab.Encodings.RealVectorEncoding {
+  public interface IRealVectorSwarmUpdater : ISwarmUpdater, IRealVectorOperator {
+    ILookupParameter<RealVector> NeighborsBestParameter { get; }
+    ILookupParameter<RealVector> PersonalBestParameter { get; }
+    ILookupParameter<RealVector> RealVectorParameter { get; }
+  }
+}
Index: trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/ParticleOperators/RealVectorNeighborhoodParticleUpdater.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/ParticleOperators/RealVectorNeighborhoodParticleUpdater.cs	(revision 5560)
+++ trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/ParticleOperators/RealVectorNeighborhoodParticleUpdater.cs	(revision 5560)
@@ -0,0 +1,67 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.RealVectorEncoding;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Encodings.RealVectorEncoding {
+  [Item("Neighborhood Particle Updater", "Updates the particle's position using (among other things) the best neighbor's position. Point = Point + Velocity*Inertia + (PersonalBestPoint-Point)*Phi_P*r_p + (BestNeighborPoint-Point)*Phi_G*r_g.")]
+  [StorableClass]
+  public sealed class RealVectorNeighborhoodParticleUpdater : RealVectorParticleUpdater, ILocalParticleUpdater {
+
+    [StorableConstructor]
+    private RealVectorNeighborhoodParticleUpdater(bool deserializing) : base(deserializing) { }
+    private RealVectorNeighborhoodParticleUpdater(RealVectorNeighborhoodParticleUpdater original, Cloner cloner) : base(original, cloner) { }
+    public RealVectorNeighborhoodParticleUpdater() : base() { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new RealVectorNeighborhoodParticleUpdater(this, cloner);
+    }
+
+    public override IOperation Apply() {
+      RealVector velocity = new RealVector(Velocity.Length);
+      RealVector position = new RealVector(RealVector.Length);
+      double r_p = Random.NextDouble();
+      double r_g = Random.NextDouble();
+      double omega = Inertia.Value;
+      double phi_p = PersonalBestAttraction.Value;
+      double phi_g = NeighborsBestAttraction.Value;
+      for (int i = 0; i < velocity.Length; i++) {
+        velocity[i] =
+          Velocity[i] * omega +
+          (PersonalBest[i] - RealVector[i]) * phi_p * r_p +
+          (NeighborsBest[i] - RealVector[i]) * phi_g * r_g;
+      }
+      BoundsChecker.Apply(velocity, VelocityBounds);
+      for (int i = 0; i < velocity.Length; i++) {
+        position[i] = RealVector[i] + velocity[i];
+      }
+      BoundsChecker.Apply(position, Bounds);
+      RealVector = position;
+      Velocity = velocity;
+
+      return base.Apply();
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/ParticleOperators/RealVectorParticleCreator.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/ParticleOperators/RealVectorParticleCreator.cs	(revision 5560)
+++ trunk/sources/HeuristicLab.Encodings.RealVectorEncoding/3.3/ParticleOperators/RealVectorParticleCreator.cs	(revision 5560)
@@ -0,0 +1,100 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System; 
+using HeuristicLab.Operators;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Encodings.RealVectorEncoding {
+  [Item("RealVectorParticleCreator", "Creates a particle with position, zero velocity vector and personal best.")]
+  [StorableClass]
+  public class RealVectorParticleCreator : SingleSuccessorOperator, IRealVectorParticleCreator {
+    #region IRealVectorParticleCreator Members
+    public ILookupParameter<IntValue> ProblemSizeParameter {
+     get { return (ILookupParameter<IntValue>)Parameters["ProblemSize"]; }
+    }
+
+    public ILookupParameter<RealVector> RealVectorParameter {
+      get { return (ILookupParameter<RealVector>)Parameters["RealVector"]; }
+    }
+
+    public ILookupParameter<RealVector> PersonalBestParameter {
+      get { return (ILookupParameter<RealVector>)Parameters["PersonalBest"]; }
+    }
+
+    public IValueLookupParameter<DoubleMatrix> BoundsParameter {
+      get { return (IValueLookupParameter<DoubleMatrix>)Parameters["Bounds"]; }
+    }
+
+    public ILookupParameter<RealVector> VelocityParameter {
+      get { return (ILookupParameter<RealVector>)Parameters["Velocity"]; }
+    }
+
+    #endregion
+
+    public RealVectorParticleCreator() : base() {
+      Parameters.Add(new LookupParameter<IntValue>("ProblemSize", "The dimension of the problem."));
+      Parameters.Add(new ValueLookupParameter<DoubleMatrix>("Bounds", "The lower and upper bounds in each dimension."));
+      Parameters.Add(new LookupParameter<RealVector>("RealVector", "Particle's current solution"));
+      Parameters.Add(new LookupParameter<RealVector>("PersonalBest", "Particle's personal best solution."));
+      Parameters.Add(new LookupParameter<RealVector>("Velocity", "Particle's current velocity."));   
+    }
+
+    public override IOperation Apply() {
+      VelocityParameter.ActualValue = new RealVector(ProblemSizeParameter.ActualValue.Value);
+      UniformRandomRealVectorCreator realVectorCreater = new UniformRandomRealVectorCreator(); 
+      Assigner personalBestPositionAssigner = new Assigner();
+
+      this.Name = "Particle Creator";
+
+      //realVectorCreater.Name = "(SolutionCreator)";
+      realVectorCreater.RealVectorParameter.ActualName = "RealVector";
+      realVectorCreater.LengthParameter.ActualName = ProblemSizeParameter.Name;
+      realVectorCreater.BoundsParameter.ActualName = BoundsParameter.Name; 
+      realVectorCreater.Successor = personalBestPositionAssigner;
+
+      personalBestPositionAssigner.LeftSideParameter.ActualName = "PersonalBest";
+      personalBestPositionAssigner.RightSideParameter.ActualName = "RealVector";
+      personalBestPositionAssigner.Successor = null; 
+
+      OperationCollection next = new OperationCollection();
+      next.Add(ExecutionContext.CreateChildOperation(realVectorCreater));
+      next.Add(base.Apply());
+      return next;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new RealVectorParticleCreator(this, cloner);
+    }
+
+    protected RealVectorParticleCreator(RealVectorParticleCreator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    [StorableConstructor]
+    protected RealVectorParticleCreator(bool deserializing) : base(deserializing) { }
+  }
+}
